/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*	"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.	*
*									*
*  Copyright (C) 1985, 1992 Lugaru Software Ltd.  All rights reserved.	*
*									*
* Limited permission is hereby granted to reproduce and modify this	*
* copyrighted material provided that the resulting code is used only in	*
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.				*
************************************************************************/

#include "eel.h"  

#if 0

when_restoring()
{
	int tflag = 0, i, j;
	char *s, teachname[FNAMELEN];

	after_loading(); /* call early, so we can display errors, etc. */
	putenv("EPSRUNS=Y");	/* for catching nested Epsilons (in DOS) */
	root_keys = reg_tab;
		/* now set buffer-specific variables */
	word_pattern.default = default_word;
	_char_class.default = _def_char_class;
	_case_map.default = _def_case_map;
	_srch_case_map.default = _def_srch_case_map;
	_display_class.default = _std_disp_class;
	_recursion_level = 0;
	i = monochrome ? _our_mono_scheme : _our_color_scheme;
	if (!i)
		i = find_index(monochrome ? "standard-mono"
					  : "standard-color");
	color_scheme = i;
	use_default = 1;		/* default is fundamental mode */
	fundamental_mode();
	use_default = 0;
	apply_defaults();	/* apply defaults to init buffer & window */
	_len_def_mac = 0;	/* at start, not defining a macro */
	run_by_mouse = 0;	/* assume cmds come from kbd */

	strcpy(_docname, "edoc");
	strcpy(teachname, "eteach");
	early_init();

	for (i = 1; i < argc && argv[i][0] == '-'; i++)
		switch (argv[i][1]) {
		case 'f':
			switch (argv[i][2]) {
			case 's':
				set_swapname(argv[i] + 3);
				break;
			case 'h':
				set_shrinkname(argv[i] + 3);
				break;
			case 'd':
				strcpy(_docname, argv[i] + 3);
				break;
			case 't':
				strcpy(teachname, argv[i] + 3);
				break;
			default:
				usage(argv[i]);
			}
			break;
		case 't':
			tflag = 1;
			break;
		case 'r':
		case 'l': break;
		case 'h': case '?': usage("");
		case 'p':
			if (!argv[i][2])
				preserve_session = !preserve_session;
			else if (isdigit(argv[i][2]))
				preserve_session = numtoi(argv[i] + 2);
			else
				cmd_line_session_file = argv[i] + 2;
			break;
		case 'd':
			s = index(argv[i] + 2, '=');
			if (s) {
				*s = 0;
				if (j = find_index(argv[i] + 2)) {
					set_var_val(j, s + 1, 1);
					break;
				}
			}			/* fall through */
		default:
			usage(argv[i]);
		}			/* i is 1st file argument */
	term_init();
#include "keyext.h"
	try_calling("key-setup");
	middle_init();
	init_menu();
	if (tflag) {
		term_cmd_line();
		to_buffer("myteach");
		if (s = lookpath(teachname))
			do_file_read(s, strip_returns.default);
		else
			error("Can't find tutorial. Install first.");
		filename = "myteach";
		preserve_session = 0;
	} else {
		if (i >= argc && load_from_state) {
			load_session();
			term_cmd_line();
		} else {
			term_cmd_line();
			load_cmd_line_files(i);
		}
		delete_dull_buffer("startup");
	}
	try_calling("start-up");
	for (i = 1; i < argc && argv[i][0] == '-'; i++)
		switch (argv[i][1]) {
			case 'l': load_commands(argv[i] + 2); break;
			case 'r': try_calling(argv[i] + 2); break;
		}
}

#else

when_restoring()
{
	int tflag = 0, i, j;
	char *s, teachname[FNAMELEN];

	after_loading(); /* call early, so we can display errors, etc. */
	putenv("EPSRUNS=Y");	/* for catching nested Epsilons (in DOS) */
	root_keys = reg_tab;
		/* now set buffer-specific variables */
	word_pattern.default = default_word;
	_char_class.default = _def_char_class;
	_case_map.default = _def_case_map;
	_srch_case_map.default = _def_srch_case_map;
	_display_class.default = _std_disp_class;
	_recursion_level = 0;
	i = monochrome ? _our_mono_scheme : _our_color_scheme;
	if (!i)
		i = find_index(monochrome ? "standard-mono"
					  : "standard-color");
	color_scheme = i;
	use_default = 1;		/* default is fundamental mode */
	fundamental_mode();
	use_default = 0;
	apply_defaults();	/* apply defaults to init buffer & window */
	_len_def_mac = 0;	/* at start, not defining a macro */
	run_by_mouse = 0;	/* assume cmds come from kbd */

	strcpy(_docname, "edoc");
	strcpy(teachname, "eteach");
	early_init();

	for (i = 1; i < argc && argv[i][0] == '-'; i++)
		switch (argv[i][1]) {
		case 'f':
			switch (argv[i][2]) {
			case 's':
				set_swapname(argv[i] + 3);
				break;
			case 'h':
				set_shrinkname(argv[i] + 3);
				break;
			case 'd':
				strcpy(_docname, argv[i] + 3);
				break;
			case 't':
				strcpy(teachname, argv[i] + 3);
				break;
			default:
				usage(argv[i]);
			}
			break;
		case 't':
			tflag = 1;
			break;
		case 'r':
		case 'l': break;
		case 'h': case '?': usage("");
		case 'p':
			if (!argv[i][2])
				preserve_session = !preserve_session;
			else if (isdigit(argv[i][2]))
				preserve_session = numtoi(argv[i] + 2);
			else
				cmd_line_session_file = argv[i] + 2;
			break;
		case 'd':
			s = index(argv[i] + 2, '=');
			if (s) {
				*s = 0;
				if (j = find_index(argv[i] + 2)) {
					set_var_val(j, s + 1, 1);
					break;
				}
			}			/* fall through */
		default:
			usage(argv[i]);
		}			/* i is 1st file argument */
	term_init();
#include "keyext.h"
	try_calling("key-setup");
	middle_init();
	init_menu();
	if (tflag) {
		term_cmd_line();
		to_buffer("myteach");
		if (s = lookpath(teachname))
			do_file_read(s, strip_returns.default);
		else
			error("Can't find tutorial. Install first.");
		filename = "myteach";
		preserve_session = 0;
	} else {
        if (load_from_state)
            load_session();
        term_cmd_line();
        if (i < argc)
            load_cmd_line_files(i);
		delete_dull_buffer("startup");
	}
	try_calling("start-up");
	for (i = 1; i < argc && argv[i][0] == '-'; i++)
		switch (argv[i][1]) {
			case 'l': load_commands(argv[i] + 2); break;
			case 'r': try_calling(argv[i] + 2); break;
		}
}

#endif

#if 0

load_cmd_line_files(i)	/* start at argv[i] */
{
	int wins = 0, tot_size = window_height, line;
	char fname[FNAMELEN], *s;

	line = -1;
	for (; i < argc; i++) {
		if (argv[i][0] == '+')
			line = strtoi(argv[i] + 1, 10);
		else {
			strcpy(fname, argv[i]);
			absolute(fname);
			s = expand_wildcards ? file_match(fname, FM_EXACT)
				: fname;
			if (!s)		/* new file */
				s = fname;
			do {
				if (wins < max_initial_windows && wins++ > 0) {
					split_window();
					window_height = 1000;
				}
				do_find(s, strip_returns.default);
				if (line > 0)
					go_line(line);
			} while (expand_wildcards
				&& (s = file_match(fname, 0)));
			line = -1;
		}
	}
	for (; window_number > 0; window_number--)
		window_height = tot_size / number_of_user_windows();
}

#else

load_cmd_line_files(i)	/* start at argv[i] */
{
	int wins = 0, tot_size, line;
	char fname[FNAMELEN], *s;

    window_one();
    tot_size = window_height;
    line = -1;
	for (; i < argc; i++) {
		if (argv[i][0] == '+')
			line = strtoi(argv[i] + 1, 10);
		else {
			strcpy(fname, argv[i]);
			absolute(fname);
			s = expand_wildcards ? file_match(fname, FM_EXACT)
				: fname;
			if (!s)		/* new file */
				s = fname;
			do {
				if (wins < max_initial_windows && wins++ > 0) {
					split_window();
					window_height = 1000;
				}
				do_find(s, strip_returns.default);
				if (line > 0)
					go_line(line);
			} while (expand_wildcards
				&& (s = file_match(fname, 0)));
			line = -1;
		}
	}
	for (; window_number > 0; window_number--)
		window_height = tot_size / number_of_user_windows();
}


#endif

delete_dull_buffer(buf)		/* delete if no file & not in window */
char *buf;
{
	int orig, keep;

	orig = bufnum;
	bufname = buf;
	keep = *filename || buf_in_window(bufnum) > 0;
	bufnum = orig;
	if (!keep)
		delete_buffer(buf);
}

usage(s)
char *s;
{
	bprintf("\r\n");
	if(*s)
		bprintf("Unrecognized flag %s on command line.\r\n", s);
	bprintf("Usage: epsilon [flags...] [files...]\r\n");
	bprintf("A file name may have +linenum before it.\r\n\r\n");

	bprintf("Flags:\r\n");
	bprintf("-sFILE   Load state from FILE%s (default: epsilon%s)\r\n",
		state_extension, state_extension);
	bprintf("-bFILE   Load state from FILE%-4s         ", byte_extension);
	bprintf("-b       Load state from epsilon%s.\r\n", byte_extension);
	bprintf("-teach   Run the tutorial.                ");
	bprintf("-rCMD    Run command or macro CMD.\r\n");
	bprintf("-p[VAL]  Set/toggle session-preserving.   ");
	bprintf("-dVAR=VAL Set variable to value.\r\n");
	bprintf("-lFILE   Load FILE%s after loading state.", byte_extension);
	bprintf("\r\n\r\n");

	bprintf("-vlNUM   Screen has NUM lines.            ");
	bprintf("-vcNUM   Screen has NUM columns.\r\n");
	bprintf("-vmono   Use monochrome color scheme.     ");
	bprintf("-vcolor  Use colors.\r\n");
#ifdef MSDOS
	bprintf("-vclean  Fast video mode.                 ");
	bprintf("-vsnow   Slow video mode.\r\n");
	bprintf("-vmNUM   Screen memory is at NUM (hex).   ");
#endif
#ifdef UNIX
	bprintf("-ksNUM   Key seq. delay in tenths of secs ");
	bprintf("-kd      Use alternate input method.\r\n");
#endif
	bprintf("-ke      Extended key support.\r\n");
	bprintf("-kcNUM   Mouse graphic cursor/block/off.  ");
	bprintf("-kmNUM   Mouse relative/absolute/off.\r\n");

#ifdef MSDOS
	bprintf("-kt      Don't take over system timer.    ");
#endif
#ifdef OS2
	bprintf("-kpNUM   Delay NUM secs starting process. ");
#endif
#ifdef UNIX
	bprintf("-kpNUM   Standard padding percentage.     ");
#endif
	bprintf("-kaNUM   Kbd compatibility flags.\r\n");

	bprintf("-fsDIRS  Swap/shrink to directories DIRS. ");
	bprintf("-fdFILE  Documentation in file FILE.\r\n");
	bprintf("-fhDIRS  Shrink to directories in DIRS.   ");
	bprintf("-ftFILE  Tutorial in file FILE.\r\n\r\n");

	bprintf("-mNUM    Use NUM bytes of main memory.    ");
	bprintf("-m0      Use minimum memory.\r\n");
	bprintf("-mNUM    Use NUM kbytes (if NUM < 1000)   ");
	bprintf("-m       Use all memory.\r\n");
#ifdef MSDOS
	bprintf("-eNUM    Like -m; sets max EMS (expanded) ");
	bprintf("-xNUM    Sets maximum XMS (extended).\r\n");
	bprintf("-eiNUM   Initial allocation of EMS.       ");
	bprintf("-xiNUM   Initial allocation of XMS.\r\n");
#endif
	file_write(TERMINAL, 1);
	leave_blank = 1;
	longjmp(top_level, 1);
}

early_init()
{
}

middle_init()
{
}

start_up()
{
	note("Epsilon Programmer's Editor %s", version);
}
